#!/usr/bin/env python
"""
FileCompletion Plugin for Python Files by Kruptein

If you press a dot after a module name a popupmenu will show with all possible options
"""
import string, inspect, os, sys

def init_dplug(dplug):
    dplug.plugins.fc = FC(dplug)
    dplug.add_to("sheetupdate","codecompletion")

def trigger(trig, dplug, val):
    """if the python plugin is activated, check whether we are editing a python file"""
    try:
        if dplug.plugins.python.python_file():
            dplug.plugins.fc.Update(val)
    except:
        dplug.plugins.fc.Update(val)

class FC():
    def __init__(self, dplug):
        self.dplug = dplug
        self.gui = dplug.main_class
        self.tempmem = [["self", []]] #self is something for later, as it is to advanced
        self.splitmem = []

    def Update(self, val):
        evt, tab = val
        if evt.GetKeyCode() == 46 or evt.GetKeyCode() == 59:
            evt.Skip()
            res = "empty"
            i = 1
            while res[0].lower() in string.lowercase + "_.":
                res = tab.editor.GetTextRange(tab.editor.GetCurrentPos() - i, tab.editor.GetCurrentPos())
                i += 1
            #Clear the whitespace
            result = res[1::]
            #check whether there are "subcalls" : sys.path.append("test")
            subcalls = result.strip().split(".")
            #Check wheter the fetched text is indeed a module/class/... (python related object)
            #First look up in temp mem
            found = False
            for i in self.tempmem:
                if i[0] == result:
                    if len(i[1]) == 0 or len(i[1]) >= 1000:  pass
                    try:
                        tab.editor.AutoCompShow(-1, i[1])
                    except TypeError:
                        pass
                    else:
                        found = True
            #Not found => import
            if len(subcalls) > 1 and not found:
                try:
                    mod = __import__(result, fromlist = subcalls[:-1])
                except ImportError:
                    #try:
                    modtemp = self.insp(subcalls, list=True)
                    mod = []
                    for i in modtemp:
                        mod.append(i)
                    if len(mod) > 1000:  self.split_mem([result, ' '.join(mod)])
                    else:
                        tab.editor.AutoCompShow(-1, ' '.join(mod))
                        self.tempmem.append([result, ' '.join(mod)])
                    #except:
                    #    mod = dir(result)
                else:
                    if len(dir(mod)) > 1000:  self.split_mem([result, ' '.join(dir(mod))])
                    else:
                        tab.editor.AutoCompShow(-1, ' '.join(dir(mod)))
                        self.tempmem.append([result, ' '.join(dir(mod))])
            elif not found:
                try:
                    mod = __import__(result)
                except ImportError:
                    #try:
                    modtemp = self.insp(result)
                    mod = []
                    for i in modtemp:
                        mod.append(i)
                    if len(mod) > 1000:  self.split_mem([result, ' '.join(mod)])
                    else:
                        tab.editor.AutoCompShow(-1, ' '.join(mod))
                        self.tempmem.append([result, ' '.join(mod)])
                    #except:
                    #    mod = dir(result)
                else:
                    if len(dir(mod)) > 1000:  self.split_mem([result, ' '.join(dir(mod))])
                    else:
                        tab.editor.AutoCompShow(-1, ' '.join(dir(mod)))
                        self.tempmem.append([result, ' '.join(dir(mod))])
        elif evt.GetKeyCode() <= 256 and len(tab.editor.GetTextRange(tab.editor.GetCurrentPos() - 1, tab.editor.GetCurrentPos())) > 0:
            #try:
            i = chr(evt.GetKeyCode())
            dot = ord(tab.editor.GetTextRange(tab.editor.GetCurrentPos() - 1, tab.editor.GetCurrentPos()))
            if i in string.letters and dot == 46 or dot == 59:
                res = "empty"
                k = 3
                while res[0].lower() in string.lowercase + "_":
                    res = tab.editor.GetTextRange(tab.editor.GetCurrentPos() - k, tab.editor.GetCurrentPos() - 1)
                    k += 1
                res = res[1:]
                for j in self.splitmem:
                    if res == j[0]:
                        if j[1][0][0] == i:
                            return self.show(j[1], tab)
                        else:   continue
            #except (ValueError, TypeError):
            #     pass
    
    def show(self, ret, tab):
        tab.editor.AutoCompShow(-1, ret)
    
    def insp(self, res, list = False):
        tab = self.gui.get_active_tab()
        #curr_dir = os.getcwd()
        #os.chdir(os.path.split(tab.path)[0])
        path = os.path.dirname(tab.path)
        sys.path.append(path)
        try:
            obj = __import__(res)
        except (ImportError, TypeError):
            obj = self.get_object(res, list)
        try:
            return obj.func_code.co_varnames
        except AttributeError:
            j = []
            for i in inspect.getmembers(obj):
                j.append(i[0])
            return j
        #os.chdir(curr_dir)
    
    def get_object(self, res, list):
        tab = self.gui.get_active_tab()
        try:
            res[0] = sys.modules[res[0]]
        except (ImportError, KeyError):
            if list:    res.insert(0, tab.name[:-3])
            else:   res = [tab.name[:-3], res]
            try:
                res[0] = sys.modules[res[0]]
            except KeyError:
                return False
        try:
            while len(res) > 1:
                temp = getattr(res[0], res[1])
                res.pop(0)
                res[0] = temp
            return temp
        except AttributeError:
            return False
    
    def split_mem(self, i):
        """Split tempmem to make lists larger as 500 items faster accessible"""
        if i[0] not in self.splitmem and len(i[1]) > 1000:
            i[1] = i[1].split(" ")
            i[1].sort()
            current = ord(i[1][0][0]) # ord("A") if A is first character
            self.splitmem.append([i[0], [ i[1][0] ] ])
            for j in i[1][1:]:
                if j[0] == chr(current):    self.splitmem[-1][1].append(j)
                else:
                    self.splitmem[-1][1] = " ".join(self.splitmem[-1][1])
                    current += 1 #MODIFY! with difference between start new and start old
                    if current == 91:   current = 97
                    if current == 122: return
                    self.splitmem.append([i[0], [j]])
            if len(self.splitmem[-1][1]) > 1:  self.splitmem[-1][1] = " ".join(self.splitmem[-1][1])
